/*
 * Systick.c
 *
 * Created: 11.09.2017 10:25:41
 *  Author: ingo
 */ 

#include "main.h"
#include "Funktionen.h"
#include "uart.h"

ISR ( TIMEBASE_200US ){
	
	static uint16_t LED_Counter = 0xffff;
	static uint16_t SysCount = 0xffff;
	static uint16_t Beeperstate = OFF;
	static uint16_t LEDState = OFF;
	static uint16_t StartupDelay = 1250;
	
	if ( StartupDelay ) StartupDelay--;
	else{
		
		SET_DEBUG_PIN();
		//////////////////////////////////////////////////////////////////////////
		SysCount++;
		LED_Counter++;
		//////////////////////////////////////////////////////////////////////////
		if ( Beeperstate ) {
			Beeperstate--;
			BEEP_SPEAKER();
		}else{
			QUIET_SPEAKER();
		}
		//////////////////////////////////////////////////////////////////////////
		if ( LED_Counter >= 2500 ){
			LED_Counter = 0;
			if ( LEDState ){
				switch ( LEDState ){
					case 1 ... 10:	Configure_LED( LED_GN, TOGGLE); break;
					case 11 ... 20:	Configure_LED( LED_GE, TOGGLE); break;
					case 21:		Configure_LED( LED_RT, TOGGLE); break;
					default: break;
				}
			}else if ( Flags.State == STATE_LISTEN && Sensivity == 0 ){
				Configure_LED( LED_GE, TOGGLE );
			}else if ( Flags.State == STATE_LISTEN && Sensivity == SENSIVITY_VALUE/2 ){
				Configure_LED( LED_RT, TOGGLE );
			}else if ( Flags.State == STATE_LISTEN && Sensivity == -SENSIVITY_VALUE/2 ){
				Configure_LED( LED_GN, TOGGLE );
			}else{
				Configure_LED( ALL_LED, CLEAR );
			}
		}
		//////////////////////////////////////////////////////////////////////////
		if ( SysCount % 4 == 0 ){// Sample with 1,25kHz
			static uint8_t TransmissionSlowDown = 0xff;
			START_ADC();
			if ( ++TransmissionSlowDown >= 125 ){
				Flags.USART_Transmission = ON;
				TransmissionSlowDown = 0;
			}
		}
		//////////////////////////////////////////////////////////////////////////
		if ( SysCount % 4 == 2  && Flags.State == STATE_LISTEN ){// Read ADC
			static uint16_t Buffer[NR_OF_CONVERSATIONS];
			static uint8_t Index = 0;
			int32_t BufferSum = 0;

			Buffer[Index] = ADC;
			for ( uint8_t i=0; i < NR_OF_CONVERSATIONS; i++ ){
				BufferSum += Buffer[i];
			}
			BufferSum /= NR_OF_CONVERSATIONS;
			BufferSum = ((BufferSum*SENSIVITY_VALUE)/1023) - SENSIVITY_VALUE/2; 
			Sensivity = BufferSum;
			BufferSum = ((int16_t)ZeroDuty) + Sensivity;
			if ( BufferSum > 255 ) BufferSum = 255;
			else if ( BufferSum < 0 ) BufferSum = 0;
			OCR0B = BufferSum;
			
			if( ++Index >= NR_OF_CONVERSATIONS ) Index = 0;
		}
		//////////////////////////////////////////////////////////////////////////
		if ( SysCount % 4 == 3 ){
			static uint16_t Countwindow = 0;
			if ( ++Countwindow >= SCANWINDOW_TIME && Flags.State == STATE_LISTEN ){
				Countwindow = 0;
				LightningsPerSekond = GetTimerDiff();
				if ( LightningsPerSekond > LIGHTNIS_PER_SECOND_MAX ) LightningsPerSekond = LIGHTNIS_PER_SECOND_MAX;
				if ( LightningsPerSekond ) {
					Beeperstate = BEEPTIME;
					LEDState = LightningsPerSekond;
					LED_Counter = 2500;
				}else{
					LEDState = 0;
				}
			}else if ( ++Countwindow >= SCANWINDOW_TIME/10 && Flags.State == STATE_GET_PWM_ZERO ){
				Countwindow = 0;
				LightningsPerSekond = GetTimerDiff();
				if ( LightningsPerSekond ) {
					Beeperstate = BEEPTIME;
					LEDState = LightningsPerSekond;
					LED_Counter = 2500;
					Flags.State = STATE_LISTEN;
					OCR0B = ((uint16_t) OCR0B * 80) / 100;
					ZeroDuty = OCR0B;
				}else{
					if ( OCR0B < 199 ) OCR0B++;
				}
			}
		}
		//////////////////////////////////////////////////////////////////////////
		CLEAR_DEBUG_PIN();
	}
}
