/*
 * main.h
 *
 * Created: 11.09.2017 10:22:46
 *  Author: ingo
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#define OFF						0
#define ON						1
#define NR_OF_CONVERSATIONS		16
#define BEEPTIME				125
#define SCANWINDOW_TIME			1250			//1s
//#define SCANWINDOW_TIME			625			//500ms

#define SET_DEBUG_PIN()		(PORTB |= (1<<PB0))
#define CLEAR_DEBUG_PIN()	(PORTB &= ~(1<<PB0))
#define TOGGLE_DEBUG_PIN()	(PINB |= (1<<PB0))
#define BEEP_SPEAKER()		(PINB |= (1<<PB1))
#define QUIET_SPEAKER()		(PORTB &= ~(1<<PB1))
#define TIMEBASE_200US		TIMER0_OVF_vect
#define START_ADC()			(ADCSRA |= (1<<ADSC))
#define ENABLE_PWM_OUT()	(TOCPMCOE |= (1<<TOCC6OE))		
#define DISABLE_PWM_OUT()	(TOCPMCOE &= ~(1<<TOCC6OE))		
#define START_PWM_VALUE		80
#define SENSIVITY_VALUE		80

#define STATE_GET_PWM_ZERO	0
#define STATE_LISTEN		1

#define LIGHTNIS_PER_SECOND_MAX	21



struct Flags_s{
	uint8_t USART_Transmission;
	uint8_t State;
};

extern volatile struct Flags_s Flags;
extern uint16_t LightningsPerSekond; 	
extern int8_t Sensivity;
extern uint16_t ZeroDuty;
	
